
unit Log;

interface

uses
  SysUtils;

type
  TLog = class
    class procedure Append(const ALine: string);
  end;

implementation

var LFile: text;

class procedure TLog.Append(const ALine: string);
begin
{.$IFDEF DEBUG}
  WriteLn(LFile, Concat(DateTimeToStr(Now()), ' ', ALine));
  Flush(LFile);
{.$ENDIF}
end;

var
  LName: string;
  
initialization
  LName := ChangeFileExt(ParamStr(0), '.log');
{.$IFDEF DEBUG}
  Assign(LFile, LName);
  if FileExists(LName) then
    Append(LFile)
  else
    Rewrite(LFile);
finalization
  Close(LFile);
{.$ENDIF}
end.
